import { world } from "@minecraft/server";
import {
    ActionFormData,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui";
var undoHolder = [];
var count = 0;

world.afterEvents.playerPlaceBlock.subscribe((event) => {
    const player = event.player; // Player that place the block
    const block = event.block; // Block that's placed

    if(block.typeId === "pa:constructor"){
        form.show(player).then(async r => {
            // This will stop the code when the player closes the form
            if (r.canceled) return;
            let response = r.selection;
            let x = event.block.x;
            let y = event.block.y;
            let z = event.block.z;
            player.runCommandAsync(`setblock ${x} ${y} ${z} air`);
    switch (response) {
                case 0:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~21 0 ~21`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 32d91fde-5418-4713-8ffb-3c322cf9f5b0${count} ${x+0} ${y} ${z+0} ${x+20} ${y+30} ${z+20}`);

        allUndoCommand.push({
          "name":`32d91fde-5418-4713-8ffb-3c322cf9f5b0${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 32d91fde-5418-4713-8ffb-3c322cf9f5b0 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 1:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~20 0 ~21`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 55b5f0d3-0bb0-49a0-b371-e056b83786dd${count} ${x+0} ${y} ${z+0} ${x+19} ${y+59} ${z+20}`);

        allUndoCommand.push({
          "name":`55b5f0d3-0bb0-49a0-b371-e056b83786dd${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 55b5f0d3-0bb0-49a0-b371-e056b83786dd ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 2:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~38 0 ~22`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 3238e90e-c787-4bf3-9438-7def9b0cdf71${count} ${x+0} ${y} ${z+0} ${x+37} ${y+40} ${z+21}`);

        allUndoCommand.push({
          "name":`3238e90e-c787-4bf3-9438-7def9b0cdf71${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 3238e90e-c787-4bf3-9438-7def9b0cdf71 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 3:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~15 0 ~15`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save c43ebd9c-d6bf-465d-8b1b-eac2628d67b1${count} ${x+0} ${y} ${z+0} ${x+14} ${y+15} ${z+14}`);

        allUndoCommand.push({
          "name":`c43ebd9c-d6bf-465d-8b1b-eac2628d67b1${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load c43ebd9c-d6bf-465d-8b1b-eac2628d67b1 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 4:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~19 0 ~29`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 78f5c5df-e4b5-49bd-96f8-b15acdaeb3e4${count} ${x+0} ${y} ${z+0} ${x+18} ${y+16} ${z+28}`);

        allUndoCommand.push({
          "name":`78f5c5df-e4b5-49bd-96f8-b15acdaeb3e4${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 78f5c5df-e4b5-49bd-96f8-b15acdaeb3e4 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 5:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~1 0 ~1`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save f804909b-767d-4073-8d2f-d9aa381ce3b0${count} ${x+0} ${y} ${z+0} ${x+0} ${y+1} ${z+0}`);

        allUndoCommand.push({
          "name":`f804909b-767d-4073-8d2f-d9aa381ce3b0${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load f804909b-767d-4073-8d2f-d9aa381ce3b0 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 6:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~15 0 ~29`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 6328fd0b-9c3e-44e9-9a21-092a7ed5d2b3${count} ${x+0} ${y} ${z+0} ${x+14} ${y+16} ${z+28}`);

        allUndoCommand.push({
          "name":`6328fd0b-9c3e-44e9-9a21-092a7ed5d2b3${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 6328fd0b-9c3e-44e9-9a21-092a7ed5d2b3 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 7:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~14 0 ~13`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 60fa611e-0cbf-4381-b0c4-849c6f18306e${count} ${x+0} ${y} ${z+0} ${x+13} ${y+14} ${z+12}`);

        allUndoCommand.push({
          "name":`60fa611e-0cbf-4381-b0c4-849c6f18306e${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 60fa611e-0cbf-4381-b0c4-849c6f18306e ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 8:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~11 0 ~11`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 8f80c429-4801-49fd-b0d9-4ac1a2379701${count} ${x+0} ${y} ${z+0} ${x+10} ${y+16} ${z+10}`);

        allUndoCommand.push({
          "name":`8f80c429-4801-49fd-b0d9-4ac1a2379701${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 8f80c429-4801-49fd-b0d9-4ac1a2379701 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 9:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~25 0 ~28`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save d4858ca0-6dac-4bda-b78a-59fbe9a36835${count} ${x+0} ${y} ${z+0} ${x+24} ${y+23} ${z+27}`);

        allUndoCommand.push({
          "name":`d4858ca0-6dac-4bda-b78a-59fbe9a36835${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load d4858ca0-6dac-4bda-b78a-59fbe9a36835 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 10:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~41 0 ~54`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save ad0d0e21-71a9-4328-a686-59aa20202df1${count} ${x+0} ${y} ${z+0} ${x+40} ${y+60} ${z+53}`);

        allUndoCommand.push({
          "name":`ad0d0e21-71a9-4328-a686-59aa20202df1${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load ad0d0e21-71a9-4328-a686-59aa20202df1 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 11:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~52 0 ~35`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save a742af5c-9967-47ca-b1ad-d1a5f2abe66c${count} ${x+0} ${y} ${z+0} ${x+51} ${y+70} ${z+34}`);

        allUndoCommand.push({
          "name":`a742af5c-9967-47ca-b1ad-d1a5f2abe66c${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load a742af5c-9967-47ca-b1ad-d1a5f2abe66c ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 12:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~33 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 22ea58b3-ac40-4cfa-9922-439feb8b6b64${count} ${x+0} ${y} ${z+0} ${x+32} ${y+50} ${z+31}`);

        allUndoCommand.push({
          "name":`22ea58b3-ac40-4cfa-9922-439feb8b6b64${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 22ea58b3-ac40-4cfa-9922-439feb8b6b64 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 13:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~22 0 ~23`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 74151302-42bf-4262-9e8f-1f7e00501991${count} ${x+0} ${y} ${z+0} ${x+21} ${y+57} ${z+22}`);

        allUndoCommand.push({
          "name":`74151302-42bf-4262-9e8f-1f7e00501991${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 74151302-42bf-4262-9e8f-1f7e00501991 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 14:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~59 0 ~49`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 455eb255-0c48-418b-9201-1e852ede0af6${count} ${x+0} ${y} ${z+0} ${x+58} ${y+60} ${z+48}`);

        allUndoCommand.push({
          "name":`455eb255-0c48-418b-9201-1e852ede0af6${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 455eb255-0c48-418b-9201-1e852ede0af6 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 15:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~25 0 ~25`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 0e95382a-88bc-4531-ae63-b7dd593806fc${count} ${x+0} ${y} ${z+0} ${x+24} ${y+30} ${z+24}`);

        allUndoCommand.push({
          "name":`0e95382a-88bc-4531-ae63-b7dd593806fc${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 0e95382a-88bc-4531-ae63-b7dd593806fc ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 16:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~15 0 ~20`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save f45e8d00-283a-4d05-b259-208c1cd9efe4${count} ${x+0} ${y} ${z+0} ${x+14} ${y+24} ${z+19}`);

        allUndoCommand.push({
          "name":`f45e8d00-283a-4d05-b259-208c1cd9efe4${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load f45e8d00-283a-4d05-b259-208c1cd9efe4 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 17:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~32 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save f066f6a3-0630-4ec9-a42b-d1ad6402eb2c${count} ${x+0} ${y} ${z+0} ${x+31} ${y+75} ${z+31}`);

        allUndoCommand.push({
          "name":`f066f6a3-0630-4ec9-a42b-d1ad6402eb2c${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load f066f6a3-0630-4ec9-a42b-d1ad6402eb2c ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 18:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~27 0 ~27`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save bb9a87f8-c0e9-4b66-97de-5c522a84b455${count} ${x+0} ${y} ${z+0} ${x+26} ${y+33} ${z+26}`);

        allUndoCommand.push({
          "name":`bb9a87f8-c0e9-4b66-97de-5c522a84b455${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load bb9a87f8-c0e9-4b66-97de-5c522a84b455 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 19:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~21 0 ~21`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save dde6bbfd-8afd-4f0e-907c-db1f07f7509e${count} ${x+0} ${y} ${z+0} ${x+20} ${y+30} ${z+20}`);

        allUndoCommand.push({
          "name":`dde6bbfd-8afd-4f0e-907c-db1f07f7509e${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load dde6bbfd-8afd-4f0e-907c-db1f07f7509e ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 20:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~33 0 ~32`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 05530419-fd68-4c6a-b0a9-54c33d291bc9${count} ${x+0} ${y} ${z+0} ${x+32} ${y+30} ${z+31}`);

        allUndoCommand.push({
          "name":`05530419-fd68-4c6a-b0a9-54c33d291bc9${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 05530419-fd68-4c6a-b0a9-54c33d291bc9 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 21:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~35 0 ~34`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 68d56b72-1315-44bb-8314-74623552e454${count} ${x+0} ${y} ${z+0} ${x+34} ${y+50} ${z+33}`);

        allUndoCommand.push({
          "name":`68d56b72-1315-44bb-8314-74623552e454${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 68d56b72-1315-44bb-8314-74623552e454 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 22:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~11 0 ~31`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 482a2d0f-74d7-4c87-83eb-ef55eef5d2bc${count} ${x+0} ${y} ${z+0} ${x+10} ${y+18} ${z+30}`);

        allUndoCommand.push({
          "name":`482a2d0f-74d7-4c87-83eb-ef55eef5d2bc${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 482a2d0f-74d7-4c87-83eb-ef55eef5d2bc ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 23:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~17 0 ~33`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save d090e5a0-0350-4df3-9a17-f542dfed3fc1${count} ${x+0} ${y} ${z+0} ${x+16} ${y+35} ${z+32}`);

        allUndoCommand.push({
          "name":`d090e5a0-0350-4df3-9a17-f542dfed3fc1${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load d090e5a0-0350-4df3-9a17-f542dfed3fc1 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 24:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~20 0 ~19`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 23725cde-f784-4a16-bd4c-dc4705a45113${count} ${x+0} ${y} ${z+0} ${x+19} ${y+37} ${z+18}`);

        allUndoCommand.push({
          "name":`23725cde-f784-4a16-bd4c-dc4705a45113${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 23725cde-f784-4a16-bd4c-dc4705a45113 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 25:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~15 0 ~24`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save c6b76174-a8f4-47c7-8bd5-5354529393fa${count} ${x+0} ${y} ${z+0} ${x+14} ${y+17} ${z+23}`);

        allUndoCommand.push({
          "name":`c6b76174-a8f4-47c7-8bd5-5354529393fa${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load c6b76174-a8f4-47c7-8bd5-5354529393fa ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 26:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~23 0 ~23`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save d0770d71-485e-4c2b-bce3-e9c02eea4dd8${count} ${x+0} ${y} ${z+0} ${x+22} ${y+58} ${z+22}`);

        allUndoCommand.push({
          "name":`d0770d71-485e-4c2b-bce3-e9c02eea4dd8${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load d0770d71-485e-4c2b-bce3-e9c02eea4dd8 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 27:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~13 0 ~17`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save f4b0c7ca-7ac5-4617-aa2b-f9cd561f75a7${count} ${x+0} ${y} ${z+0} ${x+12} ${y+35} ${z+16}`);

        allUndoCommand.push({
          "name":`f4b0c7ca-7ac5-4617-aa2b-f9cd561f75a7${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load f4b0c7ca-7ac5-4617-aa2b-f9cd561f75a7 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 28:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~31 0 ~31`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save f2f1fc1f-0432-4541-a0b3-496e482c4b87${count} ${x+0} ${y} ${z+0} ${x+30} ${y+18} ${z+30}`);

        allUndoCommand.push({
          "name":`f2f1fc1f-0432-4541-a0b3-496e482c4b87${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load f2f1fc1f-0432-4541-a0b3-496e482c4b87 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 29:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~29 0 ~18`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save d39cc075-432d-4f95-8ca1-8616297ae25f${count} ${x+0} ${y} ${z+0} ${x+28} ${y+45} ${z+17}`);

        allUndoCommand.push({
          "name":`d39cc075-432d-4f95-8ca1-8616297ae25f${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load d39cc075-432d-4f95-8ca1-8616297ae25f ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 30:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~38 0 ~64`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save c86f4350-b299-4be2-ac7c-ce599357b163${count} ${x+0} ${y} ${z+0} ${x+37} ${y+42} ${z+63}`);

        allUndoCommand.push({
          "name":`c86f4350-b299-4be2-ac7c-ce599357b163${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load c86f4350-b299-4be2-ac7c-ce599357b163 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 31:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~33 0 ~30`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 38a70b2f-c054-4622-b900-f6dd7bd88323${count} ${x+0} ${y} ${z+0} ${x+32} ${y+28} ${z+29}`);

        allUndoCommand.push({
          "name":`38a70b2f-c054-4622-b900-f6dd7bd88323${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 38a70b2f-c054-4622-b900-f6dd7bd88323 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 32:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~64 0 ~61`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save aa613df3-402d-477a-bf41-cc91200f5c07${count} ${x+0} ${y} ${z+0} ${x+63} ${y+25} ${z+60}`);

        allUndoCommand.push({
          "name":`aa613df3-402d-477a-bf41-cc91200f5c07${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load aa613df3-402d-477a-bf41-cc91200f5c07 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 33:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~29 0 ~22`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 2ba749c3-8d7f-44d4-a322-e1092e39a298${count} ${x+0} ${y} ${z+0} ${x+28} ${y+40} ${z+21}`);

        allUndoCommand.push({
          "name":`2ba749c3-8d7f-44d4-a322-e1092e39a298${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 2ba749c3-8d7f-44d4-a322-e1092e39a298 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 34:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~63 0 ~63`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save d87750a2-a15e-444c-b73c-871d67c5f807${count} ${x+0} ${y} ${z+0} ${x+62} ${y+130} ${z+62}`);

        allUndoCommand.push({
          "name":`d87750a2-a15e-444c-b73c-871d67c5f807${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load d87750a2-a15e-444c-b73c-871d67c5f807 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 35:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~31 0 ~20`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save a8cb8098-ba86-44e0-a569-3c38ade63206${count} ${x+0} ${y} ${z+0} ${x+30} ${y+70} ${z+19}`);

        allUndoCommand.push({
          "name":`a8cb8098-ba86-44e0-a569-3c38ade63206${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load a8cb8098-ba86-44e0-a569-3c38ade63206 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 36:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~13 0 ~13`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save b2ee7436-8513-47e9-a141-fc40cd0339e4${count} ${x+0} ${y} ${z+0} ${x+12} ${y+39} ${z+12}`);

        allUndoCommand.push({
          "name":`b2ee7436-8513-47e9-a141-fc40cd0339e4${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load b2ee7436-8513-47e9-a141-fc40cd0339e4 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 37:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~52 0 ~53`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 18f15fee-6b89-4045-b123-edcd688a05b3${count} ${x+0} ${y} ${z+0} ${x+51} ${y+115} ${z+52}`);

        allUndoCommand.push({
          "name":`18f15fee-6b89-4045-b123-edcd688a05b3${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 18f15fee-6b89-4045-b123-edcd688a05b3 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 38:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~31 0 ~31`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 6c1eabb5-d8dc-4229-bd65-84aa0a26bae9${count} ${x+0} ${y} ${z+0} ${x+30} ${y+155} ${z+30}`);

        allUndoCommand.push({
          "name":`6c1eabb5-d8dc-4229-bd65-84aa0a26bae9${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 6c1eabb5-d8dc-4229-bd65-84aa0a26bae9 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 39:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~31 0 ~31`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 55eea521-d221-4c1d-86d6-27295b4f337d${count} ${x+0} ${y} ${z+0} ${x+30} ${y+155} ${z+30}`);

        allUndoCommand.push({
          "name":`55eea521-d221-4c1d-86d6-27295b4f337d${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 55eea521-d221-4c1d-86d6-27295b4f337d ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 40:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~16 0 ~15`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save fb56caa4-2c66-462e-af62-f8cbc407fc73${count} ${x+0} ${y} ${z+0} ${x+15} ${y+33} ${z+14}`);

        allUndoCommand.push({
          "name":`fb56caa4-2c66-462e-af62-f8cbc407fc73${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load fb56caa4-2c66-462e-af62-f8cbc407fc73 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 41:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~21 0 ~22`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 9d64b2c3-6030-4147-81f7-2df389621da4${count} ${x+0} ${y} ${z+0} ${x+20} ${y+59} ${z+21}`);

        allUndoCommand.push({
          "name":`9d64b2c3-6030-4147-81f7-2df389621da4${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 9d64b2c3-6030-4147-81f7-2df389621da4 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 42:
                   player.sendMessage("Start building...");
                    player.sendMessage(`Block Pos at: ${x} : ${y} : ${z}`);
                    
player.runCommandAsync(`tickingarea add ~0 0 ~0 ~23 0 ~18`);

var allUndoCommand = [];
count = count + 1;
await player.runCommandAsync(`structure save 3b7c69e4-78f6-4f30-ad47-9c0761d97020${count} ${x+0} ${y} ${z+0} ${x+22} ${y+48} ${z+17}`);

        allUndoCommand.push({
          "name":`3b7c69e4-78f6-4f30-ad47-9c0761d97020${count}`,
          "x":x+0,
          "y":y,
          "z":z+0,
        });
        
undoHolder.push({"data":allUndoCommand});
        player.runCommandAsync(`structure load 3b7c69e4-78f6-4f30-ad47-9c0761d97020 ${x+0} ${y} ${z+0}`);
        
player.runCommandAsync("tickingarea remove_all");
                    break;
                        case 43:
                   if(undoHolder.length > 0){
                            var data = undoHolder.pop();
                        for(var i = 0; i < data.data.length; i++){
                            let structureName = data.data[i].name;
                            let x = data.data[i].x;
                            let y = data.data[i].y;
                            let z = data.data[i].z;
                            world.sendMessage(`Undo Structure ${structureName} at ${x} ${y} ${z}`)
                            await player.runCommandAsync(`tickingarea add ${x} 0 ${z} ${x} 0 ${z}`);
                            await player.runCommandAsync(`structure load ${structureName} ${x} ${y} ${z}`).then(()=>{
                            player.runCommandAsync(`structure delete ${structureName}`);
                            });
                        }
                            await player.runCommandAsync(`tickingarea remove_all`);
                         }else{
                            player.sendMessage("You have nothing to undo");
                         }
                    break;
                        
                default:
                // Use this when your button doesn't have a function yet
                // You don't need to use "break" on default case
                // Remember to place the default on very bottom
            }
        });;
    }
})
///Form dialog
let form = new ActionFormData()
    .title("Build Structure")
    .body("Choose the structure")
.button("s0iderman casa", "textures/arts/32d91fde-5418-4713-8ffb-3c322cf9f5b0")
.button("tower1", "textures/arts/55b5f0d3-0bb0-49a0-b371-e056b83786dd")
.button("Tree dungeon", "textures/arts/3238e90e-c787-4bf3-9438-7def9b0cdf71")
.button("Bambu Base", "textures/arts/c43ebd9c-d6bf-465d-8b1b-eac2628d67b1")
.button("Overgrown Greenhouse", "textures/arts/78f5c5df-e4b5-49bd-96f8-b15acdaeb3e4")
.button("hall1 cmmd", "textures/arts/f804909b-767d-4073-8d2f-d9aa381ce3b0")
.button("fish", "textures/arts/6328fd0b-9c3e-44e9-9a21-092a7ed5d2b3")
.button("quartz", "textures/arts/60fa611e-0cbf-4381-b0c4-849c6f18306e")
.button("shulker", "textures/arts/8f80c429-4801-49fd-b0d9-4ac1a2379701")
.button("desrt house 2", "textures/arts/d4858ca0-6dac-4bda-b78a-59fbe9a36835")
.button("gaint mushromm", "textures/arts/ad0d0e21-71a9-4328-a686-59aa20202df1")
.button("big windmill", "textures/arts/a742af5c-9967-47ca-b1ad-d1a5f2abe66c")
.button("abandon temple 2", "textures/arts/22ea58b3-ac40-4cfa-9922-439feb8b6b64")
.button("mage tower sandy", "textures/arts/74151302-42bf-4262-9e8f-1f7e00501991")
.button("pillager mansion", "textures/arts/455eb255-0c48-418b-9201-1e852ede0af6")
.button("pinnacle", "textures/arts/0e95382a-88bc-4531-ae63-b7dd593806fc")
.button("savanna treehouse", "textures/arts/f45e8d00-283a-4d05-b259-208c1cd9efe4")
.button("swamp treehouse", "textures/arts/f066f6a3-0630-4ec9-a42b-d1ad6402eb2c")
.button("abandoned temple", "textures/arts/bb9a87f8-c0e9-4b66-97de-5c522a84b455")
.button("acacia treehouse fix", "textures/arts/dde6bbfd-8afd-4f0e-907c-db1f07f7509e")
.button("bunker", "textures/arts/05530419-fd68-4c6a-b0a9-54c33d291bc9")
.button("bathouse", "textures/arts/68d56b72-1315-44bb-8314-74623552e454")
.button("bull statue", "textures/arts/482a2d0f-74d7-4c87-83eb-ef55eef5d2bc")
.button("casa azul", "textures/arts/d090e5a0-0350-4df3-9a17-f542dfed3fc1")
.button("dark forest hous", "textures/arts/23725cde-f784-4a16-bd4c-dc4705a45113")
.button("desert statue", "textures/arts/c6b76174-a8f4-47c7-8bd5-5354529393fa")
.button("frozen toqw fix", "textures/arts/d0770d71-485e-4c2b-bce3-e9c02eea4dd8")
.button("house1taiga", "textures/arts/f4b0c7ca-7ac5-4617-aa2b-f9cd561f75a7")
.button("mayans temple", "textures/arts/f2f1fc1f-0432-4541-a0b3-496e482c4b87")
.button("mini windmill", "textures/arts/d39cc075-432d-4f95-8ca1-8616297ae25f")
.button("monastery", "textures/arts/c86f4350-b299-4be2-ac7c-ce599357b163")
.button("pillager pub", "textures/arts/38a70b2f-c054-4622-b900-f6dd7bd88323")
.button("pillqger  cqmp f1x", "textures/arts/aa613df3-402d-477a-bf41-cc91200f5c07")
.button("robust house", "textures/arts/2ba749c3-8d7f-44d4-a322-e1092e39a298")
.button("the abandoned temple", "textures/arts/d87750a2-a15e-444c-b73c-871d67c5f807")
.button("the lighthouse", "textures/arts/a8cb8098-ba86-44e0-a569-3c38ade63206")
.button("torre mini pillager", "textures/arts/b2ee7436-8513-47e9-a141-fc40cd0339e4")
.button("trehouse bih", "textures/arts/18f15fee-6b89-4045-b123-edcd688a05b3")
.button("deserthall tower", "textures/arts/6c1eabb5-d8dc-4229-bd65-84aa0a26bae9")
.button("endhall tower", "textures/arts/55eea521-d221-4c1d-86d6-27295b4f337d")
.button("house2", "textures/arts/fb56caa4-2c66-462e-af62-f8cbc407fc73")
.button("house3", "textures/arts/9d64b2c3-6030-4147-81f7-2df389621da4")
.button("house4", "textures/arts/3b7c69e4-78f6-4f30-ad47-9c0761d97020")
    .button("Undo", "textures/items/barrier");
    